const fs = require('fs');
const path = require('path');
const Redpack = require('weixin-redpack').Redpack;
const moment = require('moment');
const thunkify = require('thunkify');

const getLocalIP = function() {
  const os = require('os');
  let hostName = os.hostname();
  let IPv4;
  for (var i = 0; i < os.networkInterfaces().en0.length; i++) {
    if (os.networkInterfaces().en0[i].family == 'IPv4') {
      IPv4 = os.networkInterfaces().en0[i].address;
    }
  }
  return IPv4;
}

module.exports = {
  send: function*(opts) {
    let {
      openid,
      amount,
      act
    } = opts;
    act = act || '购物抽红包';
    let billNum = `huixuan${moment().format('YYYYMMDDHHmmsssss')}` + Math.random().toString().substr(2, 3);
    let redpack = Redpack({
      mch_id: '1437208902',
      partner_key: '03CF90756A431370E5B2614F6DEEDAAA',
      pfx: fs.readFileSync(path.join(__dirname, './certs/apiclient_cert.p12')),
      wxappid: 'wx88d545a5def0d88f'
    });
    let result = yield thunkify(redpack.send).call(redpack, {
      mch_billno: billNum,
      send_name: '惠选购物助手',
      wishing: act,
      re_openid: openid,
      total_amount: amount * 100,
      total_num: 1,
      client_ip: '127.0.0.1',
      act_name: act
    });
    return result;
  }
};
